/*------------------------------------------------------------------------------
	SC51P03A04
	main.c

 ------------------------------------------------------------------------------*/
#include <Register\MCU_1007.h>
#include "main.h"
#include "led.h"

sbit	LEVEL_SDA20 = P2^0;//Touch PAD INPUT
sbit	LEVEL_SDA21 = P2^1;//IR INPUT
//sbit	Uart_P00 = P0^0;//Uart INPUT

void Touch_Read_Byte(void);
void IR_Read_Byte(void);
void IR_Read_Byte2(void);
void LEDTimer100ms(void);
void TimerStart_TouchPAD(void);//15MS
void TimerStart_IR(void);//40MS
unsigned char data   TOUCH_READ_DATA _at_	0x50;// READ Touch PAD DATA
unsigned char data   IR_READ_DATA   _at_	0x51;// READ IR DATA
unsigned char data   IR_READ_DATA1  _at_	0x52;// READ IR DATA
unsigned char data   IR_READ_DATA2  _at_	0x53;// READ IR DATA
unsigned char data   IR_READ_DATA3  _at_	0x54;// READ IR DATA

unsigned char data   IR_READ_DATA4  _at_	0x55;// TouchPAD DATA
unsigned char data   IR_READ_DATA5  _at_	0x56;// IR DATA
unsigned char data   IR_READ_DATA9  _at_	0x57;// IR PWM1/PWM2 ON DATA

unsigned char data   IR_READ_DATA6  _at_	0x58;// READ IR DATA
unsigned char data   IR_READ_DATA7  _at_	0x59;// READ IR DATA
unsigned char data   IR_READ_DATA8  _at_	0x5A;// READ IR DATA

unsigned char data   IR_READ_DATA10 _at_	0x5B;// READ IR DATA
unsigned char data   IR_READ_DATA11  _at_	0x5C;// Backup DATA
unsigned char data   IR_READ_DATA12  _at_	0x5D;// Backup IR DATA

unsigned char data   IR_READ_DATA13 _at_	0x60;// READ IR DATA
unsigned char data   IR_READ_DATA14  _at_	0x61;// Backup DATA
unsigned char data   IR_READ_DATA15  _at_	0x62;// Backup IR DATA
unsigned char data   TIMER_DATA1     _at_	0x63;// TIMER DATA
unsigned char data   TIMER_DATA2     _at_	0x64;// TIMER DATA
unsigned char data   TIMER_DATA3     _at_	0x65;// TIMER DATA
unsigned char data   TIMER_DATA4     _at_	0x66;// TIMER DATA
bit data  IR_LEDONOFF;//
bit data  ALL_LED_ONOFF;//
bit data  TIMER_60Second;//
bit data  TIMER_120Second;//
bit data  TIMER_180Second;//
bit data  TIMER_3600Second;//
extern void GO_STOP_MODE(void);
extern unsigned char data   LEDONDATA1;// LED ON data
extern unsigned char data   LEDONDATA2;// LED ON data
extern unsigned char data   LEDONDATA3;// LED ON data
extern unsigned char data   READ_UARTDATA1;// READ UART data1
extern bit data  Mode_change;//mode change
/***********************************************
@brief	SLEEP_HANDLE
@param	no
***********************************************/
//void SLEEP_HANDLE(void)
//{
//	if((IR_READ_DATA4==0x00)||(IR_READ_DATA5==0x00))
//	{
//		GO_STOP_MODE();//Goto IDLE MODE
//		//DELAY_A();
//	}
//}
/***********************************************
@brief	Read_I2C =>Read 6 Byte data
@param	no            Send 2 Byte data
@return no
***********************************************/
void Read_DATA(void)
{
	unsigned int	data i;
	unsigned int data j;
	unsigned char k;
	unsigned char h;

	if(Mode_change==0)
	{
		if(LEVEL_SDA20==0)
		{
			for(h=0;h<1;h++)
			 for(k=0;k<47;k++);//delay 100us
			if(LEVEL_SDA20==1)return;//
			TimerStart_TouchPAD();//15ms Timer Start 
			Touch_Read_Byte();//Touch PAD 1Byte DATA Read
			if(TF0==1)//15ms Timer out?
			{
				TF0 = 0;//Time0 Flag clear
				TR0 = 0;//Turb off the Timer0
				 return;
			}
			TF0 = 0;//Time0 Flag clear
			TR0 = 0;//Turb off the Timer0
			if(IR_READ_DATA10==TOUCH_READ_DATA)//data save
			{
			}
			else
			{
				IR_READ_DATA10=TOUCH_READ_DATA;//data save
				if((IR_READ_DATA10==0xA0))//LED ON/OFF
				{
					LEDONDATA1++;//+1
					if(LEDONDATA1==0x01)
					{
						if(IR_LEDONOFF==0)
						{
							ALL_LED_ONOFF=0;//Flag clear
							IR_READ_DATA5=0x5B;
							IR_READ_DATA4=0xAB;
							IR_READ_DATA11=IR_READ_DATA5;//Backup DATA
							IR_READ_DATA12=IR_READ_DATA4;//Backup DATA
						}
						else
						{
							ALL_LED_ONOFF=0;//Flag clear
							IR_READ_DATA5=IR_READ_DATA11;//Backup DATA
							IR_READ_DATA4=IR_READ_DATA12;//Backup DATA
							IR_READ_DATA8=0x00;//Count clear
							IR_READ_DATA9=0x58;//All LED ON
						}
					}
					else
					{
					 LEDONDATA1=0x00;//Count Clear
					 IR_LEDONOFF=1;//Flag to 1
					 ALL_LED_ONOFF=1;//Flag to 1
					 TIMER_60Second=0; //Timing Flag clear
					 TIMER_120Second=0;//Timing Flag clear
					 TIMER_180Second=0;//Timing Flag clear
					 TIMER_DATA1=0x00;//Timer Count clear
					 TIMER_DATA2=0x00;//Timer Count clear
					 TIMER_DATA3=0x00;//Timer Count clear
					}
				}
				else if(IR_READ_DATA10==0xA2)//-
				{
					IR_READ_DATA13++;// COUNT +1
					switch(IR_READ_DATA13)
					{
						case 0x01://0000 0001
						 IR_READ_DATA14=0x04;
						 IR_READ_DATA4=0xAA;//Duty1/2
							break;
						case 0x02://0000 0010 
						 IR_READ_DATA14=0x03;
						 IR_READ_DATA4=0xAB;//Duty1/3
							break;	
						case 0x03://0000 0011
						 IR_READ_DATA14=0x02;
						 IR_READ_DATA4=0xAC;//Duty1/4
							break;
						case 0x04://0000 0100 
						 IR_READ_DATA14=0x01;
						 IR_READ_DATA13=0x03;
						 IR_READ_DATA4=0xAD;//Duty1/5
							break;
						default:
							break;
					}
					IR_READ_DATA12=IR_READ_DATA4;//Backup DATA
					//IR_READ_DATA5=0x00;//DATA clear
				}
				else if(IR_READ_DATA10==0xA3)//+
				{	
					IR_READ_DATA14++;// COUNT +1
					switch(IR_READ_DATA14)
					{
						case 0x01://0000 0001
						 IR_READ_DATA13=0x04;
						 IR_READ_DATA4=0xAD;//Duty1/5
							break;
						case 0x02://0000 0010 
						 IR_READ_DATA13=0x03;
						 IR_READ_DATA4=0xAC;//Duty1/4
							break;
						case 0x03://0000 0010 
						 IR_READ_DATA13=0x02;
						 IR_READ_DATA4=0xAB;//Duty1/3
							break;
						case 0x04://0000 0010 
						 IR_READ_DATA13=0x01;
						 IR_READ_DATA14=0x03;
						 IR_READ_DATA4=0xAA;//Duty1/2
							break;
						default:
							break;
					}
					IR_READ_DATA12=IR_READ_DATA4;//Backup DATA
					//IR_READ_DATA5=0x00;//DATA clear
				}
				else if(IR_READ_DATA10==0xA1)//PWM ON/OFF
				{
					IR_READ_DATA8++;// COUNT +1
					switch(IR_READ_DATA8)
					{
						case 0x01://0000 0001
						 IR_READ_DATA9=0x56;
							break;
						case 0x02://0000 0010 
						 IR_READ_DATA9=0x57;
							break;	
						case 0x03://0000 0011 
						 IR_READ_DATA8=0x00;
						 IR_READ_DATA9=0x58;
							break;
						default:
							break;
					}
				}	
			}
			if(LEVEL_SDA20==1)
			{
				for(i=0;i<5;i++){//Delay 5ms
					for(j=0;j<210;j++){
					}
				}
				DELAY_A();//Delay 300us
				if(LEVEL_SDA20==0)
				{
				}
				else
				{
					IR_READ_DATA10=0xFF;
				}
			}	
		}
		else if(LEVEL_SDA21==0)//IR INPUT
		{
			for(h=0;h<5;h++)
			 for(k=0;k<47;k++);//delay 500us
			if(LEVEL_SDA21==1)return;//
			TimerStart_IR();//70ms Timer Start 
			while(!LEVEL_SDA21) // LEVEL_SDA1 Low=>Wait
			{                   // Head Hight bit
				if(TF0==1)//error?
				{
					TF0 = 0;//Time0 Flag clear
					TR0 = 0;//Turb off the Timer0
					return;
				}
			}
			while(LEVEL_SDA21) // LEVEL_SDA1 Hight=>Wait
			{                  // Head Low bit
				if(TF0==1)//error?
				{
					TF0 = 0;//Time0 Flag clear
					TR0 = 0;//Turb off the Timer0
					return;
				}
			}
			IR_Read_Byte();//IR DATA 1Byte DATA Read
			IR_READ_DATA1=IR_READ_DATA;//data save
			IR_Read_Byte();//IR DATA 1Byte DATA Read
			IR_READ_DATA2=IR_READ_DATA;//data save
			IR_Read_Byte();//IR DATA 1Byte DATA Read
			IR_READ_DATA3=IR_READ_DATA;//data save
			IR_Read_Byte();//IR DATA 1Byte DATA Read
			IR_READ_DATA15=IR_READ_DATA;//data save
			while(!LEVEL_SDA21) // LEVEL_SDA1 Low=>Wait
			{                   // Stop bit
				if(TF0==1)//error?
				{
					TF0 = 0;//Time0 Flag clear
					TR0 = 0;//Turb off the Timer0
					return;
				}
			}
			if(TF0==1)//error?
			{
				TF0 = 0;//Time0 Flag clear
				TR0 = 0;//Turb off the Timer0
				return;
			}
			TF0 = 0;//Time0 Flag clear
			TR0 = 0;//Turb off the Timer0
			if(IR_READ_DATA3==0x18)//LED ON/OFF
			{
				LEDONDATA1++;//+1
				if(LEDONDATA1==0x01)
				{
					if(IR_LEDONOFF==0)
					{
						ALL_LED_ONOFF=0;//Flag clear
						IR_READ_DATA5=0x5B;
						IR_READ_DATA4=0xAB;
						IR_READ_DATA11=IR_READ_DATA5;//Backup DATA
						IR_READ_DATA12=IR_READ_DATA4;//Backup DATA
					}
					else
					{
						ALL_LED_ONOFF=0;//Flag clear
						IR_READ_DATA5=IR_READ_DATA11;//Backup DATA
						IR_READ_DATA4=IR_READ_DATA12;//Backup DATA
						IR_READ_DATA8=0x00;//Count clear
						IR_READ_DATA9=0x58;//All LED ON
					}
				}
				else
				{
				 LEDONDATA1=0x00;//Count Clear
				 IR_LEDONOFF=1;//Flag Clear
				 ALL_LED_ONOFF=1;//Flag to 1
				 TIMER_60Second=0; //Timing Flag clear
				 TIMER_120Second=0;//Timing Flag clear
				 TIMER_180Second=0;//Timing Flag clear
				 TIMER_DATA1=0x00;//Timer Count clear
				 TIMER_DATA2=0x00;//Timer Count clear
				 TIMER_DATA3=0x00;//Timer Count clear
				}
			}
			else if(IR_READ_DATA3==0x26)//-
			{
				IR_READ_DATA6++;// COUNT +1
				switch(IR_READ_DATA6)
				{
					case 0x01://0000 0001
					 IR_READ_DATA7=0x04;
					 IR_READ_DATA5=0x5A;//Duty1/2
						break;
					case 0x02://0000 0010 
					 IR_READ_DATA7=0x03;
					 IR_READ_DATA5=0x5B;//Duty1/3
						break;	
					case 0x03://0000 0011
					 IR_READ_DATA7=0x02;
					 IR_READ_DATA5=0x5C;//Duty1/4
						break;
					case 0x04://0000 0100 
					 IR_READ_DATA7=0x01;
					 IR_READ_DATA6=0x03;
					 IR_READ_DATA5=0x5D;//Duty1/5
						break;
					default:
						break;
				}
				IR_READ_DATA11=IR_READ_DATA5;//Backup DATA
				IR_READ_DATA4=0x00;//DATA clear
			}
			else if(IR_READ_DATA3==0x25)//+
			{	
				IR_READ_DATA7++;// COUNT +1
				switch(IR_READ_DATA7)
				{
					case 0x01://0000 0001
					 IR_READ_DATA6=0x04;
					 IR_READ_DATA5=0x5D;//Duty1/5
						break;
					case 0x02://0000 0010 
					 IR_READ_DATA6=0x03;
					 IR_READ_DATA5=0x5C;//Duty1/4
						break;
					case 0x03://0000 0010 
					 IR_READ_DATA6=0x02;
					 IR_READ_DATA5=0x5B;//Duty1/3
						break;
					case 0x04://0000 0010 
					 IR_READ_DATA6=0x01;
					 IR_READ_DATA7=0x03;
					 IR_READ_DATA5=0x5A;//Duty1/2
						break;
					default:
						break;
				}
				IR_READ_DATA11=IR_READ_DATA5;//Backup DATA
				IR_READ_DATA4=0x00;//DATA clear
			}
			else if(IR_READ_DATA3==0x0B)//PWM ON/OFF
			{
				IR_READ_DATA9=0x56;
			}
			else if(IR_READ_DATA3==0x65)//PWM ON/OFF
			{
				IR_READ_DATA9=0x57;
			}
			else if(IR_READ_DATA3==0x1A)//PWM1/PW2 ON/OFF
			{
				IR_READ_DATA9=0x58;
			}
			else if(IR_READ_DATA3==0x5B)//60S LEDOFF
			{
				TIMER_60Second=1;//60Second Timing start
				TIMER_DATA1=0x00;//Timer Count clear
				TIMER_DATA2=0x00;//Timer Count clear
				TIMER_DATA3=0x00;//Timer Count clear
			}
			else if(IR_READ_DATA3==0x29)//120S LEDOFF
			{
				TIMER_120Second=1;//120Second Timing start
				TIMER_DATA1=0x00;//Timer Count clear
				TIMER_DATA2=0x00;//Timer Count clear
				TIMER_DATA3=0x00;//Timer Count clear
			}
			else if(IR_READ_DATA3==0x0F)//180S LEDOFF
			{
				TIMER_180Second=1;//180Second Timing start
				TIMER_DATA1=0x00;//Timer Count clear
				TIMER_DATA2=0x00;//Timer Count clear
				TIMER_DATA3=0x00;//Timer Count clear
			}
		}
	}
	else
	{
		if(LEVEL_SDA20==0)//TouchPAD INPUT?
		{
			for(h=0;h<1;h++)
			 for(k=0;k<47;k++);//delay 100us
			if(LEVEL_SDA20==1)return;//
			TimerStart_TouchPAD();//15ms Timer Start 
			Touch_Read_Byte();//Touch PAD 1Byte DATA Read
			if(TF0==1)//15ms Timer out?
			{
				TF0 = 0;//Time0 Flag clear
				TR0 = 0;//Turb off the Timer0
				 return;
			}
			TF0 = 0;//Time0 Flag clear
			TR0 = 0;//Turb off the Timer0
			if(IR_READ_DATA10==TOUCH_READ_DATA)//data save
			{
			}
			else
			{
				IR_READ_DATA10=TOUCH_READ_DATA;//data save
				if(IR_READ_DATA10==0xA0)//LED ON/OFF
				{
					LEDONDATA1++;//+1
					if(LEDONDATA1==0x01)
					{
						if(IR_LEDONOFF==0)
						{
							ALL_LED_ONOFF=0;//Flag clear
							IR_READ_DATA5=0x5B;
							IR_READ_DATA4=0xAB;
							IR_READ_DATA11=IR_READ_DATA5;//Backup DATA
							IR_READ_DATA12=IR_READ_DATA4;//Backup DATA
						}
						else
						{
							ALL_LED_ONOFF=0;//Flag clear
							IR_READ_DATA5=IR_READ_DATA11;//Backup DATA
							IR_READ_DATA4=IR_READ_DATA12;//Backup DATA
							IR_READ_DATA8=0x00;//Count clear
							IR_READ_DATA9=0x58;//All LED ON
						}
					}
					else
					{
					 LEDONDATA1=0x00;//Count Clear
					 IR_LEDONOFF=1;//Flag to 1
					 ALL_LED_ONOFF=1;//Flag to 1
					 IR_READ_DATA5=0x00;//IR LED OFF
					 IR_READ_DATA4=0x00;//Touch PAD LED OFF
					 TIMER_60Second=0;//Flag Clear
					 TIMER_120Second=0;//Flag Clear
					 TIMER_180Second=0;//Flag Clear
					 LEDONDATA1=0x00;//Count Clear
					 LEDONDATA2=0x00;//Count Clear
					}
				}
				else if(IR_READ_DATA10==0xA3)//-
				{
					IR_READ_DATA13++;// COUNT +1
					switch(IR_READ_DATA13)
					{
						case 0x01://0000 0001
						 IR_READ_DATA14=0x04;
						 IR_READ_DATA4=0xAA;//Duty1/2
							break;
						case 0x02://0000 0010 
						 IR_READ_DATA14=0x03;
						 IR_READ_DATA4=0xAB;//Duty1/3
							break;	
						case 0x03://0000 0011
						 IR_READ_DATA14=0x02;
						 IR_READ_DATA4=0xAC;//Duty1/4
							break;
						case 0x04://0000 0100 
						 IR_READ_DATA14=0x01;
						 IR_READ_DATA13=0x03;
						 IR_READ_DATA4=0xAD;//Duty1/5
							break;
						default:
							break;
					}
					IR_READ_DATA12=IR_READ_DATA4;//Backup DATA
					IR_READ_DATA5=0x00;//DATA clear
				}
				else if(IR_READ_DATA10==0xA2)//+
				{	
					IR_READ_DATA14++;// COUNT +1
					switch(IR_READ_DATA14)
					{
						case 0x01://0000 0001
						 IR_READ_DATA13=0x04;
						 IR_READ_DATA4=0xAD;//Duty1/5
							break;
						case 0x02://0000 0010 
						 IR_READ_DATA13=0x03;
						 IR_READ_DATA4=0xAC;//Duty1/4
							break;
						case 0x03://0000 0010 
						 IR_READ_DATA13=0x02;
						 IR_READ_DATA4=0xAB;//Duty1/3
							break;
						case 0x04://0000 0010 
						 IR_READ_DATA13=0x01;
						 IR_READ_DATA14=0x03;
						 IR_READ_DATA4=0xAA;//Duty1/2
							break;
						default:
							break;
					}
					IR_READ_DATA12=IR_READ_DATA4;//Backup DATA
					IR_READ_DATA5=0x00;//DATA clear
				}
				else if(IR_READ_DATA10==0xA1)//PWM ON/OFF
				{
					IR_READ_DATA8++;// COUNT +1
					switch(IR_READ_DATA8)
					{
						case 0x01://0000 0001
						 IR_READ_DATA9=0x56;
							break;
						case 0x02://0000 0010 
						 IR_READ_DATA9=0x57;
							break;	
						case 0x03://0000 0011 
						 IR_READ_DATA8=0x00;
						 IR_READ_DATA9=0x58;
							break;
						default:
							break;
					}
				}	
			}
			if(LEVEL_SDA20==1)
			{
				for(i=0;i<5;i++){//Delay 5ms
					for(j=0;j<210;j++){
					}
				}
				DELAY_A();//Delay 300us
				if(LEVEL_SDA20==0)
				{
				}
				else
				{
					IR_READ_DATA10=0xFF;
				}
			}	
		}
		else if(LEVEL_SDA21==0)//IR INPUT?
		{
			for(h=0;h<5;h++)
			 for(k=0;k<47;k++);//delay 500us
			if(LEVEL_SDA21==1)return;//
			TimerStart_IR();//70ms Timer Start 
			while(!LEVEL_SDA21) // LEVEL_SDA1 Low=>Wait
			{                   // Head Hight bit
				if(TF0==1)//error?
				{
					TF0 = 0;//Time0 Flag clear
					TR0 = 0;//Turb off the Timer0
					return;
				}
			}
			while(LEVEL_SDA21) // LEVEL_SDA1 Hight=>Wait
			{                  // Head Low bit
				if(TF0==1)//error?
				{
					TF0 = 0;//Time0 Flag clear
					TR0 = 0;//Turb off the Timer0
					return;
				}
			}
			IR_Read_Byte();//IR DATA 1Byte DATA Read
			IR_READ_DATA1=IR_READ_DATA;//data save
			IR_Read_Byte();//IR DATA 1Byte DATA Read
			IR_READ_DATA2=IR_READ_DATA;//data save
			IR_Read_Byte();//IR DATA 1Byte DATA Read
			IR_READ_DATA3=IR_READ_DATA;//data save
			IR_Read_Byte();//IR DATA 1Byte DATA Read
			IR_READ_DATA15=IR_READ_DATA;//data save
			while(!LEVEL_SDA21) // LEVEL_SDA1 Low=>Wait
			{                   // Stop bit
				if(TF0==1)//error?
				{
					TF0 = 0;//Time0 Flag clear
					TR0 = 0;//Turb off the Timer0
					return;
				}
			}
			if(TF0==1)//error?
			{
				TF0 = 0;//Time0 Flag clear
				TR0 = 0;//Turb off the Timer0
				return;
			}
			TF0 = 0;//Time0 Flag clear
			TR0 = 0;//Turb off the Timer0
			if(IR_READ_DATA3==0x18)//LED ON/OFF
			{
				LEDONDATA1++;//+1
				if(LEDONDATA1==0x01)
				{
					if(IR_LEDONOFF==0)
					{
						ALL_LED_ONOFF=0;//Flag clear
						IR_READ_DATA5=0x5B;
						IR_READ_DATA4=0xAB;
						IR_READ_DATA11=IR_READ_DATA5;//Backup DATA
						IR_READ_DATA12=IR_READ_DATA4;//Backup DATA
					}
					else
					{
						ALL_LED_ONOFF=0;//Flag clear
						IR_READ_DATA5=IR_READ_DATA11;//Backup DATA
						IR_READ_DATA4=IR_READ_DATA12;//Backup DATA
						IR_READ_DATA8=0x00;//Count clear
						IR_READ_DATA9=0x58;//All LED ON
					}
				}
				else
				{
				 LEDONDATA1=0x00;//Count Clear
				 IR_LEDONOFF=1;//Flag Clear
				 ALL_LED_ONOFF=1;//Flag to 1
				 IR_READ_DATA5=0x00;//IR LED OFF
				 IR_READ_DATA4=0x00;//Touch PAD LED OFF
				 TIMER_60Second=0;//Flag Clear
				 TIMER_120Second=0;//Flag Clear
				 TIMER_180Second=0;//Flag Clear
				 LEDONDATA1=0x00;//Count Clear
				 LEDONDATA2=0x00;//Count Clear
				}
			}
			else if(IR_READ_DATA3==0x25)//-
			{
				IR_READ_DATA6++;// COUNT +1
				switch(IR_READ_DATA6)
				{
					case 0x01://0000 0001
					 IR_READ_DATA7=0x04;
					 IR_READ_DATA5=0x5A;//Duty1/2
						break;
					case 0x02://0000 0010 
					 IR_READ_DATA7=0x03;
					 IR_READ_DATA5=0x5B;//Duty1/3
						break;	
					case 0x03://0000 0011
					 IR_READ_DATA7=0x02;
					 IR_READ_DATA5=0x5C;//Duty1/4
						break;
					case 0x04://0000 0100 
					 IR_READ_DATA7=0x01;
					 IR_READ_DATA6=0x03;
					 IR_READ_DATA5=0x5D;//Duty1/5
						break;
					default:
						break;
				}
				IR_READ_DATA11=IR_READ_DATA5;//Backup DATA
				IR_READ_DATA4=0x00;//DATA clear
			}
			else if(IR_READ_DATA3==0x26)//+
			{	
				IR_READ_DATA7++;// COUNT +1
				switch(IR_READ_DATA7)
				{
					case 0x01://0000 0001
					 IR_READ_DATA6=0x04;
					 IR_READ_DATA5=0x5D;//Duty1/5
						break;
					case 0x02://0000 0010 
					 IR_READ_DATA6=0x03;
					 IR_READ_DATA5=0x5C;//Duty1/4
						break;
					case 0x03://0000 0010 
					 IR_READ_DATA6=0x02;
					 IR_READ_DATA5=0x5B;//Duty1/3
						break;
					case 0x04://0000 0010 
					 IR_READ_DATA6=0x01;
					 IR_READ_DATA7=0x03;
					 IR_READ_DATA5=0x5A;//Duty1/2
						break;
					default:
						break;
				}
				IR_READ_DATA11=IR_READ_DATA5;//Backup DATA
				IR_READ_DATA4=0x00;//DATA clear
			}
			else if(IR_READ_DATA3==0x0B)//PWM ON/OFF
			{
				IR_READ_DATA9=0x56;
			}
			else if(IR_READ_DATA3==0x65)//PWM ON/OFF
			{
				IR_READ_DATA9=0x57;
			}
			else if(IR_READ_DATA3==0x1A)//PWM1/PW2 ON/OFF
			{
				IR_READ_DATA9=0x58;
			}
			else if(IR_READ_DATA3==0x5B)//60S LEDOFF
			{
				TIMER_60Second=1;//60Second Timing start
				TIMER_DATA1=0x00;//Timer Count clear
				TIMER_DATA2=0x00;//Timer Count clear
				LEDTimerStart();//100ms Timing start
			}
			else if(IR_READ_DATA3==0x29)//120S LEDOFF
			{
				TIMER_120Second=1;//120Second Timing start
				TIMER_DATA1=0x00;//Timer Count clear
				TIMER_DATA2=0x00;//Timer Count clear
				LEDTimerStart();//100ms Timing start
			}
			else if(IR_READ_DATA3==0x0F)//180S LEDOFF
			{
				TIMER_180Second=1;//180Second Timing start
				TIMER_DATA1=0x00;//Timer Count clear
				TIMER_DATA2=0x00;//Timer Count clear
				LEDTimerStart();//100ms Timing start
			}
		}
		else if(TIMER_60Second==1)//60Second Timing start?
		{
			if(TIMER_DATA1==0xC8)
			{
				TIMER_DATA1=0x00;//Timer Count clear
				TIMER_DATA2++;//Count+1
				if(TIMER_DATA2==0x03)//200*3=600*100ms=60000(60Second)
				{
					TIMER_60Second=0;//Flag Clear
					LEDONDATA1=0x00;//Count Clear
					IR_LEDONOFF=1;//Flag Clear
					ALL_LED_ONOFF=1;//Flag to 1
					IR_READ_DATA5=0x00;//IR LED OFF
					IR_READ_DATA4=0x00;//Touch PAD LED OFF
				}
			}
			else
			{
				if(TF1==1)
				{
					TIMER_DATA1++;//Count+1
					LEDTimer100ms();//100ms Timing start
				}	
			}
		}
		else if(TIMER_120Second==1)//120Second Timing start?
		{
			if(TIMER_DATA1==0xC8)
			{
				TIMER_DATA1=0x00;//Timer Count clear
				TIMER_DATA2++;//Count+1
				if(TIMER_DATA2==0x06)//200*6=1200*100ms=120000(120Second)
				{
					TIMER_120Second=0;//Flag Clear
					LEDONDATA1=0x00;//Count Clear
					IR_LEDONOFF=1;//Flag Clear
					ALL_LED_ONOFF=1;//Flag to 1
					IR_READ_DATA5=0x00;//IR LED OFF
					IR_READ_DATA4=0x00;//Touch PAD LED OFF
				}
			}
			else
			{
				if(TF1==1)
				{
					TIMER_DATA1++;//Count+1
					LEDTimer100ms();//100ms Timing start
				}	
			}
		}
		else if(TIMER_180Second==1)//180Second Timing start?
		{
			if(TIMER_DATA1==0xC8)
			{
				TIMER_DATA1=0x00;//Timer Count clear
				TIMER_DATA2++;//Count+1
				if(TIMER_DATA2==0x09)//200*9=1800*100ms=180000(180Second)
				{
					TIMER_180Second=0;//Flag Clear
					LEDONDATA1=0x00;//Count Clear
					IR_LEDONOFF=1;//Flag Clear
					ALL_LED_ONOFF=1;//Flag to 1
					IR_READ_DATA5=0x00;//IR LED OFF
					IR_READ_DATA4=0x00;//Touch PAD LED OFF
				}
			}
			else
			{
				if(TF1==1)
				{
					TIMER_DATA1++;//Count+1
					LEDTimer100ms();//100ms Timing start
				}	
			}
		}
		else if(TIMER_3600Second==1)//1hour Timing start?
		{
			if(TIMER_DATA1==0xC8)
			{
				TIMER_DATA1=0x00;//Timer Count clear
				TIMER_DATA2++;//Count+1
				if(TIMER_DATA2==0xB4)//200*180=36000*100ms=3600000ms(1hour)
				{
					if(READ_UARTDATA1==0x4)
					{	
						TIMER_3600Second=0;//Flag Clear
						LEDONDATA1=0x00;//Count Clear
						IR_LEDONOFF=1;//Flag Clear
						ALL_LED_ONOFF=1;//Flag to 1
						IR_READ_DATA5=0x00;//IR LED OFF
						IR_READ_DATA4=0x00;//Touch PAD LED OFF
					}
					else
					{
						TIMER_3600Second=0;//Flag Clear
						ALL_LED_ONOFF=0;//Flag clear
						IR_READ_DATA5=0x5B;
						IR_READ_DATA4=0xAB;
						IR_READ_DATA11=IR_READ_DATA5;//Backup DATA
						IR_READ_DATA12=IR_READ_DATA4;//Backup DATA
					}
				}
			}
			else
			{
				if(TF1==1)
				{
					TIMER_DATA1++;//Count+1
					LEDTimer100ms();//100ms Timing start
				}	
			}
		}
	}
}
/***********************************************
@brief	LEDONOFF1MS
@param	no
@return no
***********************************************/
void LEDTimer100ms(void)
{
  //EA = 0;
	TR0 = 0;
	TL0 = 0xE5;// 0xF9E5 = D63973
  TH0 = 0xF9;//65536-63973*64us=100032us100.032ms
	TF0 = 0;
  TR0 = 1;
	//EA = 1;
}
/***********************************************
@brief	LEDONOFF1MS
@param	no
@return no
***********************************************/
void TimerStart_TouchPAD(void)
{
  //EA = 0;
	TR0 = 0;
	TL0 = 0x15;// 0xFF15 = D65301
  TH0 = 0xFF;//65536-65301*64us=15040us15.04ms
	TF0 = 0;
  TR0 = 1;
	//EA = 1;
}
/***********************************************
@brief	LEDONOFF1MS
@param	no
@return no
***********************************************/
void TimerStart_IR(void)
{
  //EA = 0;
	TR0 = 0;
	TL0 = 0xBA;// 0xFBBA = D64442
  TH0 = 0xFB;//65536-64442*64us=70016us70.016ms
	TF0 = 0;
  TR0 = 1;
	//EA = 1;
}
/***********************************************
@brief	Touch_Read_Byte =>Read 1 Byte data
@param	no
@return no
***********************************************/
void Touch_Read_Byte(void)
{
	unsigned char i=0;
	unsigned char k;
	unsigned char j;
  for(i=0;i<8;i++)
  {
		TOUCH_READ_DATA<<=1;
	  for(j=0;j<5;j++)  //500us delay
		  for(k=0;k<47;k++);
		if(LEVEL_SDA20==1) //LEVEL_SDA20 = Hight?
		{
			TOUCH_READ_DATA |= 0x00;
			while(LEVEL_SDA20) //LEVEL_SDA20 Hight=>Wait
			{
				if(TF0==1)
				{
					return;
				}
			}
		}
		else
		{
			TOUCH_READ_DATA |= 0x01;
			while(!LEVEL_SDA20) //LEVEL_SDA20 Low=>Wait
			{
				if(TF0==1)
				{
					return;
				}
			}
			while(LEVEL_SDA20) //LEVEL_SDA20 Hight=>Wait
			{
				if(TF0==1)
				{
					return;
				}
			}
		}
  }
	while(!LEVEL_SDA20)    //LEVEL_SDA20 Low=>Wait
	{
		if(TF0==1)
		{
			return;
		}
	}
}	
/***********************************************
@brief	IR_Read_Byte =>Read 1 Byte data
@param	no
@return no
***********************************************/
void IR_Read_Byte(void)//Read 1Byte data
{
	unsigned char i=8;
	unsigned char k;
	unsigned char j;
  while(i--)
	{
		IR_READ_DATA>>=1;
		while(!LEVEL_SDA21)//LEVEL_SDA21 Low=>Wait
		{
			if(TF0==1)
			{
				return;
			}
		}
		for(j=0;j<8;j++)  //800us delay
			for(k=0;k<47;k++);
		if(LEVEL_SDA21==1) //LEVEL_SDA21 = Hight?
		{
			IR_READ_DATA |= 0x80;
			while(LEVEL_SDA21) //LEVEL_SDA21 Hight=>Wait
			{
				if(TF0==1)
				{
					return;
				}
			}
		}
		else
		{
			IR_READ_DATA |= 0x00;
		}
	}
}