/*------------------------------------------------------------------------------
	SC51P03A04
	led.c
 ------------------------------------------------------------------------------*/
#include <Register\MCU_1007.h>
#include "main.h"
#include "led.h"

void LEDONOFF(void);//
unsigned char data   LEDONOFF_DUTY     _at_	0x19;// LED ON/OFF 1/4 duty judge
unsigned char data   LEDONOFF_DUTY11   _at_	0x1A;// LED ON/OFF 1/4 duty judge
unsigned char data   LEDONOFF_Backup1  _at_	0x40;// LED ON/OFF Backup1
unsigned char data   LEDONOFF_Backup2  _at_	0x41;// LED ON/OFF Backup2

extern unsigned char data   IR_READ_DATA4;// TouchPAD DATA
extern unsigned char data   IR_READ_DATA5;// IR DATA
extern unsigned char data   IR_READ_DATA9;// IR PWM1/PWM2 ON DATA
extern bit data  ALL_LED_ONOFF;//

void CARRIER_MAKE(unsigned char code *PtrA);

unsigned char code LEDONOFF2_CARRIER[2] = {194,193};// 4MHz/32000Hz Duty1/2
unsigned char code LEDONOFF3_CARRIER[2] = {173,214};// 4MHz/32000Hz Duty1/3
unsigned char code LEDONOFF4_CARRIER[2] = {162,225};// 4MHz/32000Hz Duty1/4
unsigned char code LEDONOFF5_CARRIER[2] = {154,233};// 4MHz/32000Hz Duty1/5

//**********************************************
//  LED NO/OFF(1ms off/1ms no)
//**********************************************
void LEDONOFF(void)
{
	//clear_WDT();		// clear watch dog timer
	//LEDOFF12(); // P12 LED OFF
	//LEDOFF13(); // P13 LED OFF
	if(ALL_LED_ONOFF==1)//LED ON/OFF
	{
		LEDOFF30(); // P30 LED OFF
		LEDOFF12(); // P12 LED OFF
		LEDOFF13(); // P13 LED OFF
	}
	else
	{
		if((IR_READ_DATA5==0x00)&&(IR_READ_DATA4==0x00))
		{
			LEDOFF30(); // P30 LED OFF
			LEDOFF12(); // P12 LED OFF
	    LEDOFF13(); // P13 LED OFF
		}
		else
		{
			if((LEDONOFF_Backup1!=IR_READ_DATA4)||(LEDONOFF_Backup2!=IR_READ_DATA5))
			{
				if((IR_READ_DATA5==0x5D)||(IR_READ_DATA4==0xAD))//IR PWM2 DUTY 1/5
				{
					CARRIER_MAKE(&LEDONOFF2_CARRIER[0]);//DUTY 1/5
				}
				else if((IR_READ_DATA5==0x5C)||(IR_READ_DATA4==0xAC))//IR PWM2 DUTY 1/4
				{
					CARRIER_MAKE(&LEDONOFF3_CARRIER[0]);//DUTY 1/4
				}
				else if((IR_READ_DATA5==0x5B)||(IR_READ_DATA4==0xAB))//IR PWM2 DUTY 1/3
				{
					CARRIER_MAKE(&LEDONOFF4_CARRIER[0]);//DUTY 1/3
				}
				else if((IR_READ_DATA5==0x5A)||(IR_READ_DATA4==0xAA))//IR PWM2 DUTY 1/2
				{
					CARRIER_MAKE(&LEDONOFF5_CARRIER[0]);//DUTY 1/2
				}
				LEDONOFF_Backup1=IR_READ_DATA4;//DATA Backup
				LEDONOFF_Backup2=IR_READ_DATA5;//DATA Backup
			}
			if(IR_READ_DATA9==0x56)//IR PWM ON/OFF
			{
				LEDOFF13();//P13 PWM1 LED OFF
				LEDON12(); //P12 LED ON
			}
			else if(IR_READ_DATA9==0x57)//IR PWM ON/OFF
			{
				LEDOFF12();//P12 PWM2 LED OFF
				LEDON13(); //P13 LED ON
			}
			else
			{
				LEDON12(); // P12 LED ON
				LEDON13(); // P13 LED ON
			}
			LEDON30(); // P30 LED ON
		}
  }
}

/***********************************************
@brief	load carrier freq.
@param	carrier setting
@return no
************************************************/
void CARRIER_MAKE(unsigned char code *PtrA)
{
  CRGDATA0 = *PtrA;
  PtrA++;
  CRGDATA1 = *PtrA ;
  xIOMUX0=0xC0;//P30=REM, P13=GPIO
  CRGCON1 |= 0x80; //REM is active
  CRGCON2 = 0x00; //prescaler

}
//////--------------------------------------
////// Timer 1 interrupt 
//////--------------------------------------
//void TIMER1_ISR (void) interrupt 3
//{// write code here
////	 P30=1;
//   F_Timer4  = 1;  //
//	 TF1 = 0;
//}
///**********************************************
////  LED NO/OFF(1ms off/1ms no)
//***********************************************/
//void LED4mson12msoff(void)
//{
//	if((I2CDATA2==0x00)&&(I2CDATA3==0x00))
//	{
//    LED_ALLOFF(); //All LED clear
//		return;       //Power on
//	}
//	if((F_Timer1==0)&&(F_Timer2==0))
//	 {
//    LED_ON_HANDLE1();// Byte1 Hiht 4bit LED ON	 
//    LEDONOFF4ms();   // LED ON/OFF 4mS		
//    F_Timer1 = 1;	   // Timer1 Flag1=1
//	 }
// }
//	
//  if(F_Timer1 == 1)  // Flag=1
//	{
//	 if(F_Timer4==1)
//	 {
//		if(F_Timer3==1)
//		{
//     LED_ON_HANDLE4();// Byte2 Low 4bit LED ON	
//     LEDONOFF4ms();   // LED ON/OFF 4mS
//	   F_Timer1 = 0;    // Timer1 Flag1 clear 
//		 F_Timer2 = 1;    // Timer1 Flag2=1
//		 F_Timer3 = 1;	  // Timer3 Flag1=1
//		}
//		else
//		{
//     LED_ON_HANDLE2();// Byte1 Low 4bit LED ON	
//     LEDONOFF4ms();   // LED ON/OFF 4mS		
//	   F_Timer1 = 0;    // Timer1 Flag1 clear 
//		 F_Timer2 = 1;    // Timer1 Flag2=1
//		}			
//	 }
//	}
//	else
//	{
//	 if(F_Timer2 == 1)
//	 {
//	  if(F_Timer4==1)
//		{
//		 if(F_Timer3==1)
//		 {
//		  F_Timer2 = 0;  // Timer2 Flag1 clear 
//		  F_Timer1 = 0;	 // Timer1 Flag1 clear 
//		  F_Timer3 = 0;	 // Timer3 Flag1 clear 
//      TF1=0;
//		 }
//		 else
//		 {
//			 LED_ON_HANDLE3();// Byte2 Hiht 4bit LED ON	 
//			 LEDONOFF4ms();   // LED ON/OFF 4mS	
//			 F_Timer2 = 0;    // Timer2 Flag1 clear 
//			 F_Timer1 = 1;	  // Timer1 Flag1=1
//			 F_Timer3 = 1;	  // Timer3 Flag1=1
//		 }			 
//	  }
//	 }
//	 else
//	 {
//    LED_ON_HANDLE1();// Byte1 Hiht 4bit LED ON	 
//    LEDONOFF4ms();   // LED ON/OFF 4mS		
//    F_Timer1 = 1;	   // Timer1 Flag1=1
//	 }
//  }
//}
///***********************************************
//@brief	LEDONOFF4MS
//@param	no
//@return no
//***********************************************/
//void LEDONOFF4ms(void)
//{
//	EA = 0;
//	TR1 = 0;
//	TL1 = 0xC2; // 0xFFC1 = Dx65474
//  TH1 = 0xFF; //65536-65474*64us=3968us3.968ms
//	TF1 = 0;
//	ET1=1;
//  TR1 = 1;
//	F_Timer4  = 0; 
//	LED_ONOFF_TIME1++;
//	if(LED_ONOFF_TIME1==0xFF)
//	{
//	 LED_ONOFF_TIME1=0x00;
//	 LED_ONOFF_TIME2++;// Timer +1
//	}
//	EA = 1;
//}
///***********************************************
//@brief	LED_ON_HANDLE1//HANDLE1 Byte2 Hight 4bit
//@param	no
//***********************************************/
//void LED_ON_HANDLE1(void)
//{
//	 LEDONDATA1=I2CDATA2;
//	 LEDONDATA2=((LEDONDATA1&0xF0)>>4);//Obtain Byte2 Hight 4bit
//	 if(LEDONDATA2!=0)                 //0?
//	 {
//		 LEDON16();     // P16 DCDC ON
//     LEDOFF04();    // P04 LED OFF
//     LEDOFF03();    // P03 LED OFF
//	   LEDOFF15();    // P15 LED OFF
//     LEDOFF06();    // P06 LED OFF
//		 LEDOFF01();    // P01 Q12 OFF
//		 LEDOFF14();    // P01 Q13 OFF
//		 LEDOFF17();    // P01 Q14 OFF
//		 LEDON02();     // P01 Q11 ON

//	  switch(LEDONDATA2)//HANDLE DATA
//		{
//			case 0x1://0001 LED14 ON
//       LED23ON();
//				break;
//			case 0x2://0010 LED13 ON
//			 LED22ON();
//				break;
//			case 0x3://0011 LED13/LED14 ON
//			 LED2223ON();
//				break;	
//			case 0x4://0100 LED12 ON
//			 LED21ON();
//				break;
//			case 0x5://0101 LED12/LED14 ON
//			 LED2123ON();
//				break;				
//			case 0x6://0110 LED12/LED13 ON
//			 LED2122ON();
//				break;				
//			case 0x7://0111 LED12/LED13/LED14 ON
//			 LED212223ON();
//				break;	
//			case 0x8://1000 LED11 ON
//			 LED20ON();
//				break;			
//			case 0x9://1001 LED11/LED14 ON
//			 LED2023ON();
//				break;
//			case 0xA://1010 LED11/LED13 ON
//			 LED2022ON();
//				break;	
//			case 0xB://1011 LED11/LED13/LED14 ON
//			 LED202223ON();
//				break;	
//			case 0xC://1100 LED11/LED12 ON
//			 LED2021ON();
//				break;	
//			case 0xD://1101 LED11/LED12/LED14 ON
//			 LED202123ON();
//				break;
//			case 0xE://1110 LED11/LED12/LED13 ON
//			 LED202122ON();
//				break;
//			case 0xF://1111 LED11/LED12/LED13/LED14 ON
//			 LED20212223ON();
//				break;
//			default:
//				break;
//		}
//	}
//	else
//	{
//    LED_OFF_HANDLE();//clear all led
//	}
//}
///***********************************************
//@brief	LED_ON_HANDLE2//HANDLE2 Byte2 Low 4bit
//@param	no
//***********************************************/
//void LED_ON_HANDLE2(void)
//{
//	 LEDONDATA1=I2CDATA2;
//	 LEDONDATA2=(LEDONDATA1&0x0f);//Obtain Byte2 Low 4bit
//	 if(LEDONDATA2!=0)            //0?
//	 {
//		 LEDON16();     // P16 DCDC ON
//     LEDOFF04();    // P04 LED OFF
//     LEDOFF03();    // P03 LED OFF
//	   LEDOFF15();    // P15 LED OFF
//     LEDOFF06();    // P06 LED OFF
//		 LEDOFF02();    // P01 Q11 OFF
//		 LEDOFF14();    // P01 Q13 OFF
//		 LEDOFF17();    // P01 Q14 OFF
//		 LEDON01();     // P01 Q12 ON

//	  switch(LEDONDATA2)//HANDLE DATA
//		{
//			case 0x1://0001 LED23 ON
//       LED23ON();
//				break;
//			case 0x2://0010 LED22 ON
//			 LED22ON();
//				break;
//			case 0x3://0011 LED22/LED23 ON
//			 LED2223ON();
//				break;	
//			case 0x4://0100 LED21 ON
//			 LED21ON();
//				break;
//			case 0x5://0101 LED21/LED23 ON
//			 LED2123ON();
//				break;				
//			case 0x6://0110 LED21/LED22 ON
//			 LED2122ON();
//				break;				
//			case 0x7://0111 LED21/LED22/LED23 ON
//			 LED212223ON();
//				break;	
//			case 0x8://1000 LED20 ON
//			 LED20ON();
//				break;			
//			case 0x9://1001 LED20/LED23 ON
//			 LED2023ON();
//				break;
//			case 0xA://1010 LED20/LED22 ON
//			 LED2022ON();
//				break;	
//			case 0xB://1011 LED20/LED22/LED23 ON
//			 LED202223ON();
//				break;	
//			case 0xC://1100 LED20/LED21 ON
//			 LED2021ON();
//				break;	
//			case 0xD://1101 LED20/LED21/LED23 ON
//			 LED202123ON();
//				break;
//			case 0xE://1110 LED20/LED21/LED22 ON
//			 LED202122ON();
//				break;
//			case 0xF://1111 LED20/LED21/LED22/LED23 ON
//			 LED20212223ON();
//				break;
//			default:
//				break;
//		}
//	}
//	else
//	{
//    LED_OFF_HANDLE();//clear all led
//	}
//}
///***********************************************
//@brief	LED_ON_HANDLE2//HANDLE2 Byte1 Low 4bit
//@param	no
//***********************************************/
//void LED23ON(void)// LED23 ON
//{
//   LEDON03();      // P03 LED ON
//   LEDOFF04();     // P04 LED OFF
//	 LEDOFF15();     // P15 LED OFF
//   LEDOFF06();     // P06 LED OFF
//}
//void LED22ON(void)// LED23 ON
//{
//   LEDON04();      // P04 LED ON
//   LEDOFF03();     // P04 LED OFF
//	 LEDOFF15();     // P15 LED OFF
//   LEDOFF06();     // P06 LED OFF
//}
//void LED2223ON(void)// LED22/LED23 ON
//{
//   LEDON04();      // P04 LED ON
//   LEDON03();      // P03 LED ON
//	 LEDOFF15();     // P15 LED OFF
//   LEDOFF06();     // P06 LED OFF
//}
//void LED21ON(void)// LED21 ON
//{
//   LEDOFF04();     // P04 LED OFF
//   LEDOFF03();     // P03 LED OFF
//	 LEDON15();      // P15 LED ON
//   LEDOFF06();     // P06 LED OFF
//}
//void LED2123ON(void)// LED21/LED23 ON
//{
//   LEDOFF04();     // P04 LED OFF
//   LEDON03();      // P03 LED ON
//	 LEDON15();      // P15 LED ON
//   LEDOFF06();     // P06 LED OFF
//}
//void LED2122ON(void)// LED21/LED22 ON
//{
//   LEDON04();      // P04 LED ON
//   LEDOFF03();     // P03 LED OFF
//	 LEDON15();      // P15 LED ON
//   LEDOFF06();     // P06 LED OFF
//}
//void LED212223ON(void)// LED21/LED22/LED23 ON
//{
//   LEDON04();      // P04 LED ON
//   LEDON03();      // P03 LED ON
//	 LEDON15();      // P15 LED ON
//   LEDOFF06();     // P06 LED OFF
//}
//void LED20ON(void)// LED20 ON
//{
//   LEDOFF04();     // P04 LED OFF
//   LEDOFF03();     // P03 LED OFF
//	 LEDOFF15();     // P15 LED OFF
//   LEDON06();      // P06 LED ON
//}
//void LED2022ON(void)// LED20/LED22 ON
//{
//   LEDON04();      // P04 LED ON
//   LEDOFF03();     // P03 LED OFF
//	 LEDOFF15();     // P15 LED OFF
//   LEDON06();      // P06 LED ON
//}
//void LED2023ON(void)// LED20/LED23 ON
//{
//   LEDOFF04();     // P04 LED OFF
//   LEDON03();      // P03 LED ON
//	 LEDOFF15();     // P15 LED OFF
//   LEDON06();      // P06 LED ON
//}
//void LED202223ON(void)// LED20/LED22/LED23 ON
//{
//   LEDON04();      // P04 LED ON
//   LEDON03();      // P03 LED ON
//	 LEDOFF15();     // P15 LED OFF
//   LEDON06();      // P06 LED ON
//}
//void LED2021ON(void)// LED20/LED21 ON
//{
//   LEDOFF04();     // P04 LED OFF
//   LEDOFF03();     // P03 LED OFF
//	 LEDON15();      // P15 LED ON
//   LEDON06();      // P06 LED ON
//}
//void LED202123ON(void)// LED20/LED21/LED23 ON
//{
//   LEDOFF04();     // P04 LED OFF
//   LEDON03();      // P03 LED ON
//	 LEDON15();      // P15 LED ON
//   LEDON06();      // P06 LED ON
//}
//void LED202122ON(void)// LED20/LED21/LED22 ON
//{
//   LEDON04();      // P04 LED ON
//   LEDOFF03();     // P03 LED OFF
//	 LEDON15();      // P15 LED ON
//   LEDON06();      // P06 LED ON
//}
//void LED20212223ON(void)// LED20/LED21/LED22/LED23 ON
//{
//   LEDON04();      // P04 LED ON
//   LEDON03();      // P03 LED ON
//	 LEDON15();      // P15 LED ON
//   LEDON06();      // P06 LED ON
//}
///***********************************************
//@brief	LED_ON_HANDLE3//HANDLE3 Byte3 Hight 4bit
//@param	no
//***********************************************/
//void LED_ON_HANDLE3(void)
//{
//	 LEDONDATA1=I2CDATA3;
//	 LEDONDATA2=((LEDONDATA1&0xF0)>>4);//Obtain Byte2 Low 4bit
//	 if(LEDONDATA2!=0)                 //0?
//	 {
//		 LEDON16();     // P16 DCDC ON
//     LEDOFF04();    // P04 LED OFF
//     LEDOFF03();    // P03 LED OFF
//	   LEDOFF15();    // P15 LED OFF
//     LEDOFF06();    // P06 LED OFF
//		 LEDOFF01();    // P01 Q12 OFF
//		 LEDOFF02();    // P01 Q11 OFF
//		 LEDOFF17();    // P01 Q14 OFF
//		 LEDON14();     // P01 Q13 ON
//		 
//	  switch(LEDONDATA2)//HANDLE DATA	 
//	  {
//			case 0x1://0001 LED24 ON
//       LED23ON();
//				break;
//			case 0x2://0010 LED31 ON
//			 LED22ON();
//				break;
//			case 0x3://0011 LED31/LED24 ON
//			 LED2223ON();
//				break;	
//			case 0x4://0100 LED30 ON
//			 LED21ON();
//				break;
//			case 0x5://0101 LED21/LED23 ON
//			 LED2123ON();
//				break;				
//			case 0x6://0110 LED30/LED24 ON
//			 LED2122ON();
//				break;				
//			case 0x7://0111 LED30/LED31/LED24 ON
//			 LED212223ON();
//				break;	
//			case 0x8://1000 LED29 ON
//			 LED20ON();
//				break;			
//			case 0x9://1001 LED29/LED24 ON
//			 LED2023ON();
//				break;
//			case 0xA://1010 LED29/LED31 ON
//			 LED2022ON();
//				break;	
//			case 0xB://1011 LED29/LED31/LED24 ON
//			 LED202223ON();
//				break;	
//			case 0xC://1100 LED29/LED30 ON
//			 LED2021ON();
//				break;	
//			case 0xD://1101 LED29/LED30/LED24 ON
//			 LED202123ON();
//				break;
//			case 0xE://1110 LED29/LED30/LED31 ON
//			 LED202122ON();
//				break;
//			case 0xF://1111 LED29/LED30/LED31/LED24 ON
//			 LED20212223ON();
//				break;
//			default:
//				break;
//	  }
//	}
//	else
//	{
//    LED_OFF_HANDLE();//clear all led
//	}
//}
///***********************************************
//@brief	LED_ON_HANDLE4//HANDLE4 Byte3 Low 4bit
//@param	no
//***********************************************/
//void LED_ON_HANDLE4(void)
//{
//	 LEDONDATA1=I2CDATA3;
//	 LEDONDATA2=(LEDONDATA1&0x0f);//Obtain Byte3 Low 4bit
//	 if(LEDONDATA2!=0)            //0?
//	 {
//		 LEDON16();     // P16 DCDC ON
//     LEDOFF04();    // P04 LED OFF
//     LEDOFF03();    // P03 LED OFF
//	   LEDOFF15();    // P15 LED OFF
//     LEDOFF06();    // P06 LED OFF
//		 LEDOFF01();    // P01 Q12 OFF
//		 LEDOFF02();    // P01 Q11 OFF
//		 LEDOFF14();    // P01 Q13 OFF
//		 LEDON17();     // P01 Q14 ON	

//	  switch(LEDONDATA2)//HANDLE DATA	 
//	  {
//			case 0x1://0001 LED33 ON
//       LED23ON();
//				break;
//			case 0x2://0010 LED32 ON
//			 LED22ON();
//				break;
//			case 0x3://0011 LED32/LED33 ON
//			 LED2223ON();
//				break;	
//			case 0x4://0100 LED39 ON
//			 LED21ON();
//				break;
//			case 0x5://0101 LED39/LED33 ON
//			 LED2123ON();
//				break;				
//			case 0x6://0110 LED39/LED32 ON
//			 LED2122ON();
//				break;				
//			case 0x7://0111 LED39/LED32/LED33 ON
//			 LED212223ON();
//				break;	
//			case 0x8://1000 LED38 ON
//			 LED20ON();
//				break;			
//			case 0x9://1001 LED38/LED33 ON
//			 LED2023ON();
//				break;
//			case 0xA://1010 LED38/LED32 ON
//			 LED2022ON();
//				break;	
//			case 0xB://1011 LED38/LED32/LED33 ON
//			 LED202223ON();
//				break;	
//			case 0xC://1100 LED38/LED309ON
//			 LED2021ON();
//				break;	
//			case 0xD://1101 LED38/LED39/LED33 ON
//			 LED202123ON();
//				break;
//			case 0xE://1110 LED38/LED39/LED32 ON
//			 LED202122ON();
//				break;
//			case 0xF://1111 LED38/LED39/LED32/LED33 ON
//			 LED20212223ON();
//				break;
//			default:
//				break;
//	  }
//	}
//	else
//	{
//    LED_OFF_HANDLE();//clear all led
//	}
//}
///***********************************************
//@brief	LED_ALLOFF
//@param	no
//@return no
//************************************************/
//void LED_ALLOFF(void)
//{
//	 LEDOFF06();  // P06 LED OFF
//	 LEDOFF02();  // P02 LED OFF
//	 LEDOFF15();  // P15 LED OFF
//	 LEDOFF01();  // P01 LED OFF
//	 LEDOFF04();  // P04 LED OFF
//	 LEDOFF14();  // P14 LED OFF
//	 LEDOFF03();  // P03 LED OFF
//	 LEDOFF17();  // P17 LED OFF
//   LEDOFF16();  // P16 DCDC OFF
//	 LED_ONOFF_TIME1=0x00; //Timer clear
//	 LED_ONOFF_TIME2=0x00; //Timer clear
//	 F_Timer1= 0; //time flag clear
//	 F_Timer2= 0; //time flag clear
//	 F_Timer3= 0; //time flag clear
//}
///***********************************************
//@brief	LED_ALLOFF
//@param	no
//@return no
//************************************************/
//void LED_OFF_HANDLE(void)
//{
//	 LEDOFF06();  // P06 LED OFF
//	 LEDOFF02();  // P02 LED OFF
//	 LEDOFF15();  // P15 LED OFF
//	 LEDOFF01();  // P01 LED OFF
//	 LEDOFF04();  // P04 LED OFF
//	 LEDOFF14();  // P14 LED OFF
//	 LEDOFF03();  // P03 LED OFF
//	 LEDOFF17();  // P17 LED OFF
//   LEDOFF16();  // P16 DCDC OFF
//}
///***********************************************
//@brief	LEDONOFF1MS
//@param	no
//@return no
//***********************************************/
//void LEDONOFF1ms(void)
//{
//	EA = 0;
//	TR1 = 0;
//	TL1 = 0xF0; // 0xFFF0 = Dx65520
//  TH1 = 0xFF; //65536-65520*64us=1024us1.024ms
//	TF1 = 0;
//  TR1 = 1;
//}