/*------------------------------------------------------------------------------
	SC51P03A04
	main.c

 ------------------------------------------------------------------------------*/
#include <Register\MCU_1007.h>
#include "main.h"
#include "led.h"

#define SP_INIT 0x2F
#define INTERNAL_CLK 1
sbit	Uart_P00 = P0^0;//Uart INPUT 

bit data  F_EX0;//
bit data  F_EX1;//
bit data  F_Timer3;//flow light first keyon
bit data  F_Timer4;//Low power+flow light
bit data  F_Timer5;//Lowpower light count
bit data  Mode_change;//mode change

unsigned char data   LED_ONOFF_TIME1  _at_	0x1C;// 10s COUNT LED ON/OFF TIME1
unsigned char data   LED_ONOFF_TIME2	_at_	0x1B;// 10s COUNT LED ON/OFF TIME2
//unsigned char data   LED_ONOFF_TIME3	_at_	0x1A;// LOW POWER 500ms LED ON/OFF COUNT TIME3
//unsigned char data   LED_ONOFF_TIME4	_at_	0x19;// Flowing light 500ms LED ON/OFF COUNT TIME4
//unsigned char data   LED_ONOFF_TIME5	_at_	0x18;// Flowing light 500ms LED ON/OFF COUNT TIME5
//unsigned char data   LED_ONOFF_TIME6	_at_	0x17;// Flowing light 500ms LED ON/OFF COUNT TIME6
//unsigned char data   LED_ONOFF_TIME7	_at_	0x16;// Flowing light 500ms LED ON/OFF COUNT TIME7
//unsigned char data   LED_ONOFF_TIME8	_at_	0x15;// Flowing light 500ms LED ON/OFF COUNT TIME7

unsigned char data   LEDONDATA1        _at_	0x14;// LED ON data
unsigned char data   LEDONDATA2        _at_	0x15;// LED ON data
unsigned char data   LEDONDATA3        _at_	0x16;// LED ON data
unsigned char data   LEDONDATA4        _at_	0x17;// LED ON data
unsigned char data   LEDONDATA5        _at_	0x18;// LED ON data

extern unsigned char data   LEDONOFF_DUTY;// LED ON/OFF 1/4 duty judge
extern unsigned char data   LEDONOFF_DUTY11;// LED ON/OFF 1/4 duty judge

unsigned char data   FLOW_COUNT        _at_	0x11;// Flowing light count
unsigned char data   FLOW_COUNT11      _at_	0x10;// Flowing light count

unsigned char data   READ_UARTDATA     _at_	0x70;// READ UART data
unsigned char data   READ_UARTDATA1    _at_	0x71;// READ UART data1
//unsigned char data   READ_UARTDATA2    _at_	0x62;// READ UART data2
//unsigned char data   READ_UARTDATA3    _at_	0x64;// READ UART data3
//unsigned char data   READ_UARTDATA4    _at_	0x65;// READ UART data4
//unsigned char data   READ_UARTDATA5    _at_	0x66;// READ UART data5
//unsigned char data   READ_UARTDATA6    _at_	0x67;// READ UART data6
//unsigned char data   READ_UARTDATA7    _at_	0x68;// READ UART data7
//unsigned char data   READ_UARTDATA8    _at_	0x69;// READ UART data8
//unsigned char data   READ_UARTDATA9    _at_	0x6A;// READ UART data9
//unsigned char data   READ_UARTDATA10   _at_	0x6B;// READ UART data10

extern unsigned char data   IR_READ_DATA6;// IR DATA
extern unsigned char data   IR_READ_DATA7;// IR DATA
extern unsigned char data   IR_READ_DATA8;// IR DATA
extern unsigned char data   IR_READ_DATA11;// TouchPAD DATA
extern unsigned char data   IR_READ_DATA12;// IR DATA
extern unsigned char data   IR_READ_DATA13;// TouchPAD DATA
extern unsigned char data   IR_READ_DATA14;// IR DATA
extern unsigned char data   IR_READ_DATA4;// TouchPAD DATA
extern unsigned char data   IR_READ_DATA5;// IR DATA
extern unsigned char data   IR_READ_DATA9;// IR PWM1/PWM2 ON DATA

extern unsigned char data   TIMER_DATA1;//
extern unsigned char data   TIMER_DATA2;//
extern unsigned char data   TIMER_DATA3;//
extern bit data  ALL_LED_ONOFF;//
extern bit data  TIMER_60Second;//
extern bit data  TIMER_120Second;//
extern bit data  TIMER_180Second;//
extern bit data  TIMER_3600Second;//
extern bit data  IR_LEDONOFF;//
extern void LEDONOFF(void);//
void LED_ONOFF_SW(void);
void Read_uart(void);//
void TimerStart_Uart(void);//
void Delay104us(void);
//--------------------------------------
// External interrupt 0 
//--------------------------------------
void EX0_ISR (void) interrupt 0
{// write code here
	clear_WDT();//WDT clear
	EINTCS0 = EINTCS0 & 0xfc;  //清中断标志两次
	EINTCS0 = EINTCS0 & 0xfc;
	IE0=0; //clear flag
	EX0=0; //外部中断关闭
	EA=0;  //close interrupt
	if(Uart_P00==1)
	{
		return;
	}
	TimerStart_Uart();//3MS Timer Start
	Read_uart();
	READ_UARTDATA1=READ_UARTDATA;
	
	if(TF0==1)//error?
	{
		TF0 = 0;//Time0 Flag clear
		TR0 = 0;//Turb off the Timer0
		return;
	}
	TF0 = 0;//Time0 Flag clear
	TR0 = 0;//Turb off the Timer0
	if((READ_UARTDATA1==0x15)||(READ_UARTDATA1==0x17))//LED ON
	{
		LEDONDATA1++;//+1
		if(LEDONDATA1==0x01)
		{
			if(IR_LEDONOFF==0)
			{
				ALL_LED_ONOFF=0;//Flag clear
				IR_READ_DATA5=0x5B;
				IR_READ_DATA4=0xAB;
				IR_READ_DATA11=IR_READ_DATA5;//Backup DATA
				IR_READ_DATA12=IR_READ_DATA4;//Backup DATA
			}
			else
			{
				ALL_LED_ONOFF=0;//Flag clear
				IR_LEDONOFF=1;//Flag to 1
				IR_READ_DATA5=IR_READ_DATA11;//Backup DATA
				IR_READ_DATA4=IR_READ_DATA12;//Backup DATA
				IR_READ_DATA8=0x00;//Count clear
				IR_READ_DATA9=0x58;//All LED ON
			}
		}
	}
	else if((READ_UARTDATA1==0x16)||(READ_UARTDATA1==0x18))//LED OFF
	{
	 LEDONDATA1=0x00;//Count Clear
	 IR_LEDONOFF=1;//Flag to 1
	 ALL_LED_ONOFF=1;//Flag to 1
	 IR_READ_DATA5=0x00;//IR LED OFF
	 IR_READ_DATA4=0x00;//Touch PAD LED OFF
	}
	else if(READ_UARTDATA1==0x21)//调光+
	{
		IR_READ_DATA6++;// COUNT +1
		switch(IR_READ_DATA6)
		{
			case 0x01://0000 0001
			 IR_READ_DATA7=0x04;
			 IR_READ_DATA5=0x5A;//Duty1/2
				break;
			case 0x02://0000 0010 
			 IR_READ_DATA7=0x03;
			 IR_READ_DATA5=0x5B;//Duty1/3
				break;	
			case 0x03://0000 0011
			 IR_READ_DATA7=0x02;
			 IR_READ_DATA5=0x5C;//Duty1/4
				break;
			case 0x04://0000 0100 
			 IR_READ_DATA7=0x01;
			 IR_READ_DATA6=0x03;
			 IR_READ_DATA5=0x5D;//Duty1/5
				break;
			default:
				break;
		}
		IR_READ_DATA11=IR_READ_DATA5;//Backup DATA
		IR_READ_DATA4=0x00;//DATA clear
	}
	else if(READ_UARTDATA1==0x22)//调光-
	{	
		IR_READ_DATA7++;// COUNT +1
		switch(IR_READ_DATA7)
		{
			case 0x01://0000 0001
			 IR_READ_DATA6=0x04;
			 IR_READ_DATA5=0x5D;//Duty1/5
				break;
			case 0x02://0000 0010 
			 IR_READ_DATA6=0x03;
			 IR_READ_DATA5=0x5C;//Duty1/4
				break;
			case 0x03://0000 0010 
			 IR_READ_DATA6=0x02;
			 IR_READ_DATA5=0x5B;//Duty1/3
				break;
			case 0x04://0000 0010 
			 IR_READ_DATA6=0x01;
			 IR_READ_DATA7=0x03;
			 IR_READ_DATA5=0x5A;//Duty1/2
				break;
			default:
				break;
		}
		IR_READ_DATA11=IR_READ_DATA5;//Backup DATA
		IR_READ_DATA4=0x00;//DATA clear
	}
	else if(READ_UARTDATA1==0x19)//调到最亮
	{
		IR_READ_DATA6=0x01;
		IR_READ_DATA7=0x03;
		IR_READ_DATA5=0x5D;//Duty1/5
		IR_READ_DATA11=IR_READ_DATA5;//Backup DATA
		IR_READ_DATA4=0x00;//DATA clear
	}
	else if(READ_UARTDATA1==0x20)//调到最暗
	{
		IR_READ_DATA7=0x01;
		IR_READ_DATA6=0x03;
		IR_READ_DATA5=0x5A;//Duty1/2
		IR_READ_DATA11=IR_READ_DATA5;//Backup DATA
		IR_READ_DATA4=0x00;//DATA clear
	}
	else if(READ_UARTDATA1==0x10)//PWM ON/OFF
	{
		IR_READ_DATA9=0x58;
	}
	else if(READ_UARTDATA1==0x11)//PWM ON/OFF
	{
		IR_READ_DATA9=0x57;
	}
	else if(READ_UARTDATA1==0x12)//PWM ON/OFF
	{
		IR_READ_DATA9=0x56;
	}
	else if((READ_UARTDATA1==0x4)||(READ_UARTDATA1==0x5))//1hour LED ON/OFF
	{
		TIMER_3600Second=1;//
	}
  EX0=1;//开外部中断
	EA=1; //open interrupt
}
/***********************************************
@brief	Uart_Read_Byte =>Read 1 Byte data
@param	no
@return no
***********************************************/
void Read_uart(void)
{
	unsigned char q=8;

  READ_UARTDATA=0x00;//Initial setting:0x00

  while(q--)//Read 8bit data
	{
		READ_UARTDATA>>=1;
		//P17=1;//Test user
		Delay104us();//Delay 104us
		//P17=0;//Test user
		if(Uart_P00==1)
		{
			READ_UARTDATA |= 0x80;
		}
		else
		{
			READ_UARTDATA |= 0x00;
		}
	}
	while(!Uart_P00)//Uart_P00 Low=>Wait
	{
		if(TF0==1)
		{
			return;
		}
	}
}
///***********************************
//º¯ÊýÃû³Æ: Delay20us()
//***********************************/
void Delay104us(void)
{
	U8 i=47;
	
 	clear_WDT(); 	//
	do
    {
	    i--;
    }
	while(i);
}
/***********************************************
@brief	3MS Timer Set
***********************************************/
void TimerStart_Uart(void)
{
  //EA = 0;
	TR0 = 0;
	TL0 = 0xD1;// 0xFFD1 = D65489
  TH0 = 0xFF;//(65536-65489)*64us=3008us(3.008ms)
	TF0 = 0;
  TR0 = 1;
	//EA = 1;
}
//--------------------------------------
// Timer 0 interrupt 
//--------------------------------------
void TIMER0_ISR (void) interrupt 1
{
	// write code here
}

//--------------------------------------
// External 1 interrupt 
//--------------------------------------
void EX1_ISR (void) interrupt 2
{
  // write code here
}
//--------------------------------------
// Timer 1 interrupt 
//--------------------------------------
void TIMER1_ISR (void) interrupt 3
{	// write code here
	clear_WDT();		// clear watch dog timer
	LEDOFF12(); // P12 LED OFF
	LEDOFF13(); // P13 LED OFF
	if(ALL_LED_ONOFF==1)//LED ON/OFF
	{//return;//LED OFF
	}
	else
	{
		if(IR_READ_DATA5==0x5D)//IR PWM2 DUTY 1/5
		{
			LEDONOFF_DUTY11++;// COUNT +1
			switch(LEDONOFF_DUTY11)//Duty HANDLE DATA  1/5
			{
				case 0x01://0000 0001
					LED_ONOFF_SW();//LED ON/OFF Switch
				 //LEDON12();// P12 LED ON
				 //LEDON13();// P13 LED ON
					break;
				case 0x02://0000 0010
				 LEDOFF12();//P12 LED OFF
				 LEDOFF13();//P13 LED OFF
					break;
				case 0x03://0000 0011
				 LEDOFF12();//P12 LED OFF
				 LEDOFF13();//P13 LED OFF
					break;	
				case 0x04://0000 0100
				 LEDOFF12();//P12 LED OFF
				 LEDOFF13();//P13 LED OFF
					break;	
				case 0x05://0000 0101 
				LEDONOFF_DUTY11=0x00;// COUNT Clear
				 LEDOFF12();//P12 LED OFF
				 LEDOFF13();//P13 LED OFF
					break;	
				default:
				 LEDONOFF_DUTY11=0x00;// COUNT Clear
					break;
			}
		}
		else if(IR_READ_DATA5==0x5C)//IR PWM2 DUTY 1/4
		{
			LEDONOFF_DUTY11++;// COUNT +1
			switch(LEDONOFF_DUTY11)//Duty HANDLE DATA  1/4
			{
				case 0x01://0000 0001
					LED_ONOFF_SW();//LED ON/OFF Switch
				 //LEDON12();// P12 LED ON
				 //LEDON13();// P13 LED ON
					break;
				case 0x02://0000 0010
				 LEDOFF12();//P12 LED OFF
				 LEDOFF13();//P13 LED OFF
					break;
				case 0x03://0000 0011
				 LEDOFF12();//P12 LED OFF
				 LEDOFF13();//P13 LED OFF
					break;	
				case 0x04://0000 0100 
				LEDONOFF_DUTY11=0x00;// COUNT Clear
				 LEDOFF12();//P12 LED OFF
				 LEDOFF13();//P13 LED OFF
					break;	
				default:
				 LEDONOFF_DUTY11=0x00;// COUNT Clear
					break;
			}
		}
		else if(IR_READ_DATA5==0x5B)//IR PWM2 DUTY 1/3
		{
			LEDONOFF_DUTY11++;// COUNT +1
			switch(LEDONOFF_DUTY11)//Duty HANDLE DATA  1/3
			{
				case 0x01://0000 0001
					LED_ONOFF_SW();//LED ON/OFF Switch
				 //LEDON12();// P12 LED ON
				 //LEDON13();// P13 LED ON
					break;
				case 0x02://0000 0010
				 LEDOFF12();//P12 LED OFF
				 LEDOFF13();//P13 LED OFF
					break;	
				case 0x03://0000 0011 
				LEDONOFF_DUTY11=0x00;// COUNT Clear
				 LEDOFF12();//P12 LED OFF
				 LEDOFF13();//P13 LED OFF
					break;	
				default:
				 LEDONOFF_DUTY11=0x00;// COUNT Clear
					break;
			}
		}
		else if(IR_READ_DATA5==0x5A)//IR PWM2 DUTY 1/2
		{
			LEDONOFF_DUTY11++;// COUNT +1
			switch(LEDONOFF_DUTY11)//Duty HANDLE DATA  1/2
			{
				case 0x01://0000 0001
					LED_ONOFF_SW();//LED ON/OFF Switch
				 //LEDON12();// P12 LED ON
				 //LEDON13();// P13 LED ON
					break;
				case 0x02://0000 0010 
				LEDONOFF_DUTY11=0x00;// COUNT Clear
				 LEDOFF12();//P12 LED OFF
				 LEDOFF13();//P13 LED OFF
					break;	
				default:
				 LEDONOFF_DUTY11=0x00;// COUNT Clear
					break;
			}
		}
		if(IR_READ_DATA4==0xAD)//TOUCH PAD PWM1 DUTY 1/5
		{
			LEDONOFF_DUTY++;// COUNT +1
			switch(LEDONOFF_DUTY)//Duty HANDLE DATA  1/5
			{
				case 0x01://0000 0001
					LED_ONOFF_SW();//LED ON/OFF Switch
				 //LEDON12();// P12 LED ON
				 //LEDON13();// P13 LED ON
					break;
				case 0x02://0000 0010
				 LEDOFF12();//P12 LED OFF
				 LEDOFF13();//P13 LED OFF
					break;
				case 0x03://0000 0011
				 LEDOFF12();//P12 LED OFF
				 LEDOFF13();//P13 LED OFF
					break;	
				case 0x04://0000 0100
				 LEDOFF12();//P12 LED OFF
				 LEDOFF13();//P13 LED OFF
					break;	
				case 0x05://0000 0101 
				LEDONOFF_DUTY=0x00;// COUNT Clear
				 LEDOFF12();//P12 LED OFF
				 LEDOFF13();//P13 LED OFF
					break;	
				default:
					break;
			}
		}
		else if(IR_READ_DATA4==0xAC)//TOUCH PAD PWM1 DUTY 1/4
		{
			LEDONOFF_DUTY++;// COUNT +1
			switch(LEDONOFF_DUTY)//Duty HANDLE DATA  1/4
			{
				case 0x01://0000 0001
					LED_ONOFF_SW();//LED ON/OFF Switch
				 //LEDON12();// P12 LED ON
				 //LEDON13();// P13 LED ON
					break;
				case 0x02://0000 0010
				 LEDOFF12();//P12 LED OFF
				 LEDOFF13();//P13 LED OFF
					break;
				case 0x03://0000 0011
				 LEDOFF12();//P12 LED OFF
				 LEDOFF13();//P13 LED OFF
					break;	
				case 0x04://0000 0100 
				LEDONOFF_DUTY=0x00;// COUNT Clear
				 LEDOFF12();//P12 LED OFF
				 LEDOFF13();//P13 LED OFF
					break;	
				default:
					break;
			}
		}
		else if(IR_READ_DATA4==0xAB)//TOUCH PAD PWM1 DUTY 1/3
		{
			LEDONOFF_DUTY++;// COUNT +1
			switch(LEDONOFF_DUTY)//Duty HANDLE DATA  1/3
			{
				case 0x01://0000 0001
					LED_ONOFF_SW();//LED ON/OFF Switch
				 //LEDON12();// P12 LED ON
				 //LEDON13();// P13 LED ON
					break;
				case 0x02://0000 0010
				 LEDOFF12();//P12 LED OFF
				 LEDOFF13();//P13 LED OFF
					break;	
				case 0x03://0000 0011 
				LEDONOFF_DUTY=0x00;// COUNT Clear
				 LEDOFF12();//P12 LED OFF
				 LEDOFF13();//P13 LED OFF
					break;	
				default:
					break;
			}
		}
		else if(IR_READ_DATA4==0xAA)//TOUCH PAD PWM1 DUTY 1/2
		{
			LEDONOFF_DUTY++;// COUNT +1
			switch(LEDONOFF_DUTY)//Duty HANDLE DATA  1/2
			{
				case 0x01://0000 0001
					LED_ONOFF_SW();//LED ON/OFF Switch
				 //LEDON12();// P12 LED ON
				 //LEDON13();// P13 LED ON
					break;
				case 0x02://0000 0010 
				LEDONOFF_DUTY=0x00;// COUNT Clear
				 LEDOFF12();//P12 LED OFF
				 LEDOFF13();//P13 LED OFF
					break;	
				default:
					break;
			 }
		}
		if(TIMER_60Second==1)//60Second Timing start?
		{
			if(TIMER_DATA1==0xFA)//250
			{
				TIMER_DATA1=0x00;//Timer Count clear
				TIMER_DATA2++;//Count+1
				if(TIMER_DATA2==0xF0)//250*240=60000(60Second)
				{
				  LEDONDATA1=0x00;//Count Clear
				  IR_LEDONOFF=1;//Flag to 1
					TIMER_60Second=0;//Flag Clear
					TIMER_DATA1=0x00;//Count Clear
					TIMER_DATA2=0x00;//Count Clear
					TIMER_DATA3=0x00;//Count Clear
					ALL_LED_ONOFF=1;//Flag to 1
				}
			}
			else
			{
				TIMER_DATA1++;//Count+1
			}
		}
		else if(TIMER_120Second==1)//120Second Timing start?
		{
			if(TIMER_DATA3==0x02)//2*60s=120s
			{
				LEDONDATA1=0x00;//Count Clear
				IR_LEDONOFF=1;//Flag to 1
				TIMER_120Second=0;//Flag Clear
				TIMER_DATA1=0x00;//Count Clear
				TIMER_DATA2=0x00;//Count Clear
				TIMER_DATA3=0x00;//Count Clear
				ALL_LED_ONOFF=1;//Flag to 1
			}
			else
			{
				if(TIMER_DATA1==0xFA)//250
				{
					TIMER_DATA1=0x00;//Timer Count clear
					TIMER_DATA2++;//Count+1
					if(TIMER_DATA2==0xF0)//250*240=60000(60Second)
					{
					  TIMER_DATA2=0x00;//Timer Count clear
					  TIMER_DATA3++;//Count+1
					}
				}
				else
				{
					TIMER_DATA1++;//Count+1
				}
			}
		}
		else if(TIMER_180Second==1)//180Second Timing start?
		{
			if(TIMER_DATA3==0x03)//3*60s=180s
			{
				LEDONDATA1=0x00;//Count Clear
				IR_LEDONOFF=1;//Flag to 1
				TIMER_180Second=0;//Flag Clear
				TIMER_DATA1=0x00;//Count Clear
				TIMER_DATA2=0x00;//Count Clear
				TIMER_DATA3=0x00;//Count Clear
				ALL_LED_ONOFF=1;//Flag to 1
			}
			else
			{
				if(TIMER_DATA1==0xFA)//250
				{
					TIMER_DATA1=0x00;//Timer Count clear
					TIMER_DATA2++;//Count+1
					if(TIMER_DATA2==0xF0)//250*240=60000(60Second)
					{
					  TIMER_DATA2=0x00;//Timer Count clear
					  TIMER_DATA3++;//Count+1
					}
				}
				else
				{
					TIMER_DATA1++;//Count+1
				}
			}
		}
  }
}
//--------------------------------------
//  P12 LED ON/P13 LED ON/P12,P13 LED ON
//--------------------------------------
void LED_ONOFF_SW(void)
{
	if(IR_READ_DATA9==0x56)//IR PWM ON/OFF
	{
		LEDON12();// P12 PWM1 LED ON
	}
	else if(IR_READ_DATA9==0x57)//IR PWM ON/OFF
	{
		LEDON13();// P13 PWM2 LED ON
	}
	else
	{
		LEDON12();// P12 LED ON
		LEDON13();// P13 LED ON
	}
}
//--------------------------------------
// CRG interrupt 
//--------------------------------------
void CRG_ISR (void) interrupt 14
{
	// write code here
}

//--------------------------------------
// KB interrupt 
//--------------------------------------
void KB_ISR (void) interrupt 20
{
	// write code here
}

//--------------------------------------
// Main Program
//--------------------------------------
void main (void)
{
	//initialize stack pointer
	SP = SP_INIT; 

  //Watch dog timer setting
	WDTCON = 0x36; //156ms
	//Wwatch dog timer starting
	clear_WDT(); 
  //delay is necessary for power stable
	DELAY_10MS();	
	//Initial Register setting 
  xIOMUX0=0x90;//P30,P13???GPIO
  P0MDL=0xAA;// 1010 1001 P01-P03 push pull
  P0MDH=0xAA;// 1010 1010 P04,P06 push pull 
  P1MDL=0xAA;// 1010 1010 P12-P13 push pull 
  P1MDH=0xA9;// 1010 1001 P15-P16 push pull   P14 INPUT
  P2MDL=0x0A;// 0000 0101 P20,P21 input
  P3MDL=0x02;// 0000 0010 P30 push pull 
	
	P15=0;
	DELAY_A();//Delay 300us
	if(P14==0)
	{
		Mode_change=1;//TP8 and TP9 ON =>P30 PWM OUTPUT
	}
	else
	{
		Mode_change=0;//TP8 and TP9 OFF =>P30 PWM OUTPUT
	}
	
	INITIAL_SET();  //System setting Register
	IR_READ_DATA6=0x01;//Initial value
	IR_READ_DATA7=0x02;//Initial value
	IR_READ_DATA13=0x01;//Initial value
	IR_READ_DATA14=0x02;//Initial value
	if(Mode_change==0)
	{
	  LEDTimerStart();//1ms定时设定开启
	}
	while(1)
	{
		INITIAL_SET2(); // Port Register Refresh
		Read_DATA();    // Read LED ON DATA
    //SLEEP_HANDLE();// DATA=0 =>Sleep
		if(Mode_change==1)
		{
			LEDONOFF();   // P30 PWM OUTPUT LED ON/OFF
		}
		clear_WDT();		// clear watch dog timer
		SP = SP_INIT;	  // initialize stack pointer
	}
}

/***********************************************
@brief	100ms wait
@param	no
@return no
***********************************************/
void DELAY_10MS(void)
{
#ifdef ASM1
#pragma asm
	MOV  	R6,#085H  ; 3cycle (133)
LOOP_DELAY_100MS:
	MOV  	R7,#0C8H  ; 3cycle (200)
LOOP_DELAY_100MS_2:
	NOP; 2cycle
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	DJNZ 	R7,LOOP_DELAY_100MS_2 ; 3 or 5cycle
	DJNZ 	R6,LOOP_DELAY_100MS ; 3 or 5cycle

#pragma endasm
#else
	unsigned int	data i;
	unsigned int data j;
	for(i=0;i<10;i++){
		for(j=0;j<210;j++){
		}
	}
#endif
}
/***********************************************
@brief	300usec???
@param	???
@return ???
***********************************************/
//----------------------------------------------------
// delay function
// 300us@4MHz(including ACALL), it is for 150K pull up
void DELAY_A(void)
{
#if 0
#pragma asm
	MOV  	R7,#0F0H  ; 240 loop
LOOP_DELAY_A:
	NOP
	NOP
	DJNZ 	R7,LOOP_DELAY_A ; 3cycle
#pragma endasm
#else
	unsigned char k;
	unsigned char j;
	for(j=0;j<3;j++)
		for(k=0;k<47;k++);
#endif

}
/***********************************************
@brief	LEDONOFF1MS
@param	no
@return no
***********************************************/
void LEDTimerStart(void)  //@0921
{
  EA = 0;
	TR1 = 0;
	TL1 = 0x83; //0x83=D131//20191031liu
  TH1 = 0x83; //256-131=125，125*8=1000us//20191031liu
	TF1 = 0;
	ET1=1;
  TR1 = 1;
	EA = 1;
}
/***********************************************
@brief	watch dog timer clear & start
@param	no
@return no
***********************************************/
void clear_WDT(void)
{
	WDTCLR0=0x00;
	WDTCLR1=0x00;
	WDTCLR0=0x53;
	WDTCLR1=0xAC;
}
/***********************************************
@brief	INITIAL_SET2
@param	no
@return no
************************************************/
void INITIAL_SET2(void)
{
  //P0MDL=0xAA;// 1010 0101 P00-P03 push pull
  P0MDH=0xAA;// 1010 1010 P04,P06 push pull 
  P1MDL=0xAA;// 1010 1010 P12-P13 push pull 
  P1MDH=0xAA;// 1010 1010 P14-P16 push pull 
  P2MDL=0x05;// 0000 0101 P20,P21 input
  P3MDL=0x02;// 0000 0010 P30 push pull 
  xKBICON = 0x03;//P20,P21 KBI enableP12-P17 KBI disable 
  xKBIWKP = 0x00;//P20 P21 Falling edge(Waken up by low level in stop mode)
	if(Mode_change==1)
	{
		P0MDL=0xA9;// 1010 1001 P02-P03 push pull,P00 input
		EINTCS0=0x50;//使能外部中断，异步
		IT0=1;//下降沿触发中断
		EX0=1;//开外部中断
		EA=1; //打开总中断
	}
	else
	{
	  P0MDL=0xAA;// 1010 0101 P00-P03 push pull
	}
}
/***********************************************
@brief	INITIAL_SET
@param	no
@return no
************************************************/
void INITIAL_SET(void)
{
  //-------------------------Interrupt
  IE=0x00;
  IP=0x00;
  EIE2=0x00;
  EIP2=0x00;
  EINTCS0=0x00;
  //-------------------------Power Management
  PCON=0x00;
  LVRCON=0x81;
  xSTOPCFG=0x08;
  RSTSRC=0;
  //-------------------------Watch dog timer
  //WDTCON
  //WDTCLR0
  //WDTCLR1
  //-------------------------Clock management
  WPKEY=0x37;
#if INTERNAL_CLK
  MCKSET=0x0b; // sysclk/1
#else
  MCKSET=0x17; // sysclk/1
  while(!(MCKSET&0x04));
#endif
//-------------------------System configuration
#if defined(BUILD_TR)
  xSYSCFG=0x63;
#else
  xSYSCFG=0x0F;
  //xSYSCFG=0x8F;//P0.5 user reset port
#endif
  //-------------------------Carrier Generator
  //???????肷??
  CRGCON1=0x00;
  CRGCON2=0x00;
  CRGDATA0=0x00;
  CRGDATA1=0x00;
  //-------------------------general purpose I/O
  //REM?[?q??GPIO????
  //TR?????A??????????????B
  //?L?[?X?L????????????
  //
  xIOMUX0=0x90;//P30,P13???GPIO

  P0MDL=0xAA;// 1010 0101 P00-P03 push pull
  P0MDH=0xAA;// 1010 1010 P04,P06 push pull 
  P1MDL=0xAA;// 1010 1010 P12-P13 push pull 
  P1MDH=0xAA;// 1010 1010 P14-P16 push pull 
  P2MDL=0x05;// 0000 0101 P20,P21 input
  P3MDL=0x02;// 0000 0010 P30 push pull 
  P0=0x00;   // Output LoW
  P1=0x00;   // Output LoW
  P2=0x00;   // Output LoW
  P3=0x00;   // Output LoW

  //-------------------------keyboard interrupt
  //????????
  //
  xKBICON=0x00;
  xKBIWKP=0x00;
  KBIFLG=0x00;
  //-------------------------timer
  //????????
  //
  TCON=0x00;
	if(Mode_change==1)
	{
		TMOD=0x11; //配置定时器1，
		TL0=0x00;
		TH0=0x00;
		TL1=0x00;
		TH1=0x00;
		xTIMPRS=0x77; // T0/T1:FCLK/ 256
	}
	else
	{
		TMOD=0x21; //配置定时器1，模式2  @0921
		TL0=0x00;
		TH0=0x00;
		TL1=0x83;	//4ms
		TH1=0x83;
	//xTIMPRS=0x02;// FCLK/8 T0:FCLK/2?????????
	//xTIMPRS=0x66;//T0/T1:FCLK/128 Frequency division 20191031liu
		xTIMPRS=0x47; // T0/T1:FCLK/ 32 Frequency division 20191031liu
	}
  //-------------------------other
  //
}